<script setup lang="ts">
import { useEmployeeStore } from '../stores/employee'

const employeeStore = useEmployeeStore()
</script>

<template>
  <v-dialog v-model="employeeStore.dialog" persistent width="1024">
    <v-card rounded="xl">
      <v-card-title>
        <span class="text-h5">Employee Profile</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="employeeStore.form" @submit.prevent="employeeStore.onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12" sm="4">
                <v-combobox
                  label="Role"
                  :items="['พนักงาน', 'ผู้จัดการ']"
                  v-model="employeeStore.editedEmployee.role"
                ></v-combobox>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.editedEmployee.firstName"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="First Name"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.editedEmployee.lastName"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Last Name"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.editedEmployee.tel"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Tel."
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="4">
                <v-combobox
                  label="Gender"
                  :items="['male', 'female', 'others']"
                  v-model="employeeStore.editedEmployee.gender"
                ></v-combobox>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.editedEmployee.birthDate"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Birth Date"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.editedEmployee.qualification"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Qualification"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.editedEmployee.moneyRate"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Money Rate"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.editedEmployee.minWork"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Min Work"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="employeeStore.editedEmployee.startDate"
                  :readonly="employeeStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Start Date"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="employeeStore.closeDialog()">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="employeeStore.save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <!-- Delete Dialog-->
  <v-dialog v-model="employeeStore.dialogDelete" max-width="500px">
    <v-card>
      <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="employeeStore.closeDelete"
          >Cancel</v-btn
        >
        <v-btn color="blue-darken-1" variant="text" @click="employeeStore.deleteItemConfirm()"
          >OK</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
